Package org.springframework.asm

# Class ClassWriter

java.lang.Object
org.springframework.asm.ClassVisitor
org.springframework.asm.ClassWriter

public class ClassWriter extends ClassVisitor
A `ClassVisitor` that generates a corresponding ClassFile structure, as defined in the Java Virtual Machine Specification (JVMS). It can be used alone, to generate a Java class "from scratch", or with one or more `ClassReader` and adapter `ClassVisitor` to generate a modified class from one or more existing Java classes.

Author:
  Eric Bruneton
See Also:
  - JVMS 4

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`COMPUTE_FRAMES`
A flag to automatically compute the stack map frames of methods from scratch.
`static final int`
`COMPUTE_MAXS`
A flag to automatically compute the maximum stack size and the maximum number of local variables of methods.

### Fields inherited from class org.springframework.asm.ClassVisitor

`api, cv`

## Constructor Summary

Constructors
Constructor
Description
`ClassWriter(int flags)`
Constructs a new `ClassWriter` object.
`ClassWriter(ClassReader classReader, int flags)`
Constructs a new `ClassWriter` object and enables optimizations for "mostly add" bytecode transformations.

## Method Summary

Modifier and Type
Method
Description
`protected ClassLoader`
`getClassLoader()`
Returns the `ClassLoader` to be used by the default implementation of `getCommonSuperClass(String, String)`, that of this `ClassWriter`'s runtime type by default.
`protected String`
`getCommonSuperClass(String type1, String type2)`
Returns the common super type of the two given types.
`boolean`
`hasFlags(int flags)`
Returns true if all the given flags were passed to the constructor.
`int`
`newClass(String value)`
Adds a class reference to the constant pool of the class being build.
`int`
`newConst(Object value)`
Adds a number or string constant to the constant pool of the class being build.
`int`
`newConstantDynamic(String name, String descriptor, Handle bootstrapMethodHandle, Object... bootstrapMethodArguments)`
Adds a dynamic constant reference to the constant pool of the class being build.
`int`
`newField(String owner, String name, String descriptor)`
Adds a field reference to the constant pool of the class being build.
`int`
`newHandle(int tag, String owner, String name, String descriptor)`
Deprecated.
this method is superseded by `newHandle(int, String, String, String, boolean)`.
`int`
`newHandle(int tag, String owner, String name, String descriptor, boolean isInterface)`
Adds a handle to the constant pool of the class being build.
`int`
`newInvokeDynamic(String name, String descriptor, Handle bootstrapMethodHandle, Object... bootstrapMethodArguments)`
Adds an invokedynamic reference to the constant pool of the class being build.
`int`
`newMethod(String owner, String name, String descriptor, boolean isInterface)`
Adds a method reference to the constant pool of the class being build.
`int`
`newMethodType(String methodDescriptor)`
Adds a method type reference to the constant pool of the class being build.
`int`
`newModule(String moduleName)`
Adds a module reference to the constant pool of the class being build.
`int`
`newNameType(String name, String descriptor)`
Adds a name and type to the constant pool of the class being build.
`int`
`newPackage(String packageName)`
Adds a package reference to the constant pool of the class being build.
`int`
`newUTF8(String value)`
Adds an UTF8 string to the constant pool of the class being build.
`final void`
`setFlags(int flags)`
Changes the computation strategy of method properties like max stack size, max number of local variables, and frames.
`byte[]`
`toByteArray()`
Returns the content of the class file that was built by this ClassWriter.
`final void`
`visit(int version, int access, String name, String signature, String superName, String[] interfaces)`
Visits the header of the class.
`final AnnotationVisitor`
`visitAnnotation(String descriptor, boolean visible)`
Visits an annotation of the class.
`final void`
`visitAttribute(Attribute attribute)`
Visits a non standard attribute of the class.
`final void`
`visitEnd()`
Visits the end of the class.
`final FieldVisitor`
`visitField(int access, String name, String descriptor, String signature, Object value)`
Visits a field of the class.
`final void`
`visitInnerClass(String name, String outerName, String innerName, int access)`
Visits information about an inner class.
`final MethodVisitor`
`visitMethod(int access, String name, String descriptor, String signature, String[] exceptions)`
Visits a method of the class.
`final ModuleVisitor`
`visitModule(String name, int access, String version)`
Visit the module corresponding to the class.
`final void`
`visitNestHost(String nestHost)`
Visits the nest host class of the class.
`final void`
`visitNestMember(String nestMember)`
Visits a member of the nest.
`final void`
`visitOuterClass(String owner, String name, String descriptor)`
Visits the enclosing class of the class.
`final void`
`visitPermittedSubclass(String permittedSubclass)`
Visits a permitted subclasses.
`final RecordComponentVisitor`
`visitRecordComponent(String name, String descriptor, String signature)`
Visits a record component of the class.
`final void`
`visitSource(String file, String debug)`
Visits the source of the class.
`final AnnotationVisitor`
`visitTypeAnnotation(int typeRef, TypePath typePath, String descriptor, boolean visible)`
Visits an annotation on a type in the class signature.

### Methods inherited from class org.springframework.asm.ClassVisitor

`getDelegate`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### COMPUTE_MAXS

public static final int COMPUTE_MAXS
A flag to automatically compute the maximum stack size and the maximum number of local variables of methods. If this flag is set, then the arguments of the `MethodVisitor.visitMaxs(int, int)` method of the `MethodVisitor` returned by the `visitMethod(int, java.lang.String, java.lang.String, java.lang.String, java.lang.String[])` method will be ignored, and computed automatically from the signature and the bytecode of each method.

Note: for classes whose version is `Opcodes.V1_7` of more, this option requires valid stack map frames. The maximum stack size is then computed from these frames, and from the bytecode instructions in between. If stack map frames are not present or must be recomputed, used `COMPUTE_FRAMES` instead.

See Also:
  - `ClassWriter(int)`
  - Constant Field Values

### COMPUTE_FRAMES

public static final int COMPUTE_FRAMES
A flag to automatically compute the stack map frames of methods from scratch. If this flag is set, then the calls to the `MethodVisitor.visitFrame(int, int, java.lang.Object[], int, java.lang.Object[])` method are ignored, and the stack map frames are recomputed from the methods bytecode. The arguments of the `MethodVisitor.visitMaxs(int, int)` method are also ignored and recomputed from the bytecode. In other words, `COMPUTE_FRAMES` implies `COMPUTE_MAXS`.

See Also:
  - `ClassWriter(int)`
  - Constant Field Values

## Constructor Details

### ClassWriter

public ClassWriter(int flags)
Constructs a new `ClassWriter` object.

Parameters:
  `flags` - option flags that can be used to modify the default behavior of this class. Must be zero or more of `COMPUTE_MAXS` and `COMPUTE_FRAMES`.

### ClassWriter

public ClassWriter(ClassReader classReader, int flags)
Constructs a new `ClassWriter` object and enables optimizations for "mostly add" bytecode transformations. These optimizations are the following:

- The constant pool and bootstrap methods from the original class are copied as is in the new class, which saves time. New constant pool entries and new bootstrap methods will be added at the end if necessary, but unused constant pool entries or bootstrap methods won't be removed.
- Methods that are not transformed are copied as is in the new class, directly from the original class bytecode (i.e. without emitting visit events for all the method instructions), which saves a lot of time. Untransformed methods are detected by the fact that the `ClassReader` receives `MethodVisitor` objects that come from a `ClassWriter` (and not from any other `ClassVisitor` instance).

Parameters:
  `classReader` - the `ClassReader` used to read the original class. It will be used to copy the entire constant pool and bootstrap methods from the original class and also to copy other fragments of original bytecode where applicable.
  `flags` - option flags that can be used to modify the default behavior of this class. Must be zero or more of `COMPUTE_MAXS` and `COMPUTE_FRAMES`. These option flags do not affect methods that are copied as is in the new class. This means that neither the maximum stack size nor the stack frames will be computed for these methods.

## Method Details

### hasFlags

public boolean hasFlags(int flags)
Returns true if all the given flags were passed to the constructor.

Parameters:
  `flags` - some option flags. Must be zero or more of `COMPUTE_MAXS` and `COMPUTE_FRAMES`.
Returns:
  true if all the given flags, or more, were passed to the constructor.

### visit

public final void visit(int version, int access, String name, String signature, String superName, String[] interfaces)
Description copied from class: `ClassVisitor`
Visits the header of the class.

Overrides:
  `visit` in class `ClassVisitor`
Parameters:
  `version` - the class version. The minor version is stored in the 16 most significant bits, and the major version in the 16 least significant bits.
  `access` - the class's access flags (see `Opcodes`). This parameter also indicates if the class is deprecated `Opcodes.ACC_DEPRECATED` or a record `Opcodes.ACC_RECORD`.
  `name` - the internal name of the class (see `Type.getInternalName()`).
  `signature` - the signature of this class. May be null if the class is not a generic one, and does not extend or implement generic classes or interfaces.
  `superName` - the internal of name of the super class (see `Type.getInternalName()`). For interfaces, the super class is `Object`. May be null, but only for the `Object` class.
  `interfaces` - the internal names of the class's interfaces (see `Type.getInternalName()`). May be null.

### visitSource

public final void visitSource(String file, String debug)
Description copied from class: `ClassVisitor`
Visits the source of the class.

Overrides:
  `visitSource` in class `ClassVisitor`
Parameters:
  `file` - the name of the source file from which the class was compiled. May be null.
  `debug` - additional debug information to compute the correspondence between source and compiled elements of the class. May be null.

### visitModule

public final ModuleVisitor visitModule(String name, int access, String version)
Description copied from class: `ClassVisitor`
Visit the module corresponding to the class.

Overrides:
  `visitModule` in class `ClassVisitor`
Parameters:
  `name` - the fully qualified name (using dots) of the module.
  `access` - the module access flags, among `ACC_OPEN`, `ACC_SYNTHETIC` and `ACC_MANDATED`.
  `version` - the module version, or null.
Returns:
  a visitor to visit the module values, or null if this visitor is not interested in visiting this module.

### visitNestHost

public final void visitNestHost(String nestHost)
Description copied from class: `ClassVisitor`
Visits the nest host class of the class. A nest is a set of classes of the same package that share access to their private members. One of these classes, called the host, lists the other members of the nest, which in turn should link to the host of their nest. This method must be called only once and only if the visited class is a non-host member of a nest. A class is implicitly its own nest, so it's invalid to call this method with the visited class name as argument.

Overrides:
  `visitNestHost` in class `ClassVisitor`
Parameters:
  `nestHost` - the internal name of the host class of the nest (see `Type.getInternalName()`).

### visitOuterClass

public final void visitOuterClass(String owner, String name, String descriptor)
Description copied from class: `ClassVisitor`
Visits the enclosing class of the class. This method must be called only if this class is a local or anonymous class. See the JVMS 4.7.7 section for more details.

Overrides:
  `visitOuterClass` in class `ClassVisitor`
Parameters:
  `owner` - internal name of the enclosing class of the class (see `Type.getInternalName()`).
  `name` - the name of the method that contains the class, or null if the class is not enclosed in a method or constructor of its enclosing class (for example, if it is enclosed in an instance initializer, static initializer, instance variable initializer, or class variable initializer).
  `descriptor` - the descriptor of the method that contains the class, or null if the class is not enclosed in a method or constructor of its enclosing class (for example, if it is enclosed in an instance initializer, static initializer, instance variable initializer, or class variable initializer).

### visitAnnotation

public final AnnotationVisitor visitAnnotation(String descriptor, boolean visible)
Description copied from class: `ClassVisitor`
Visits an annotation of the class.

Overrides:
  `visitAnnotation` in class `ClassVisitor`
Parameters:
  `descriptor` - the class descriptor of the annotation class.
  `visible` - true if the annotation is visible at runtime.
Returns:
  a visitor to visit the annotation values, or null if this visitor is not interested in visiting this annotation.

### visitTypeAnnotation

public final AnnotationVisitor visitTypeAnnotation(int typeRef, TypePath typePath, String descriptor, boolean visible)
Description copied from class: `ClassVisitor`
Visits an annotation on a type in the class signature.

Overrides:
  `visitTypeAnnotation` in class `ClassVisitor`
Parameters:
  `typeRef` - a reference to the annotated type. The sort of this type reference must be `TypeReference.CLASS_TYPE_PARAMETER`, `TypeReference.CLASS_TYPE_PARAMETER_BOUND` or `TypeReference.CLASS_EXTENDS`. See `TypeReference`.
  `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be null if the annotation targets 'typeRef' as a whole.
  `descriptor` - the class descriptor of the annotation class.
  `visible` - true if the annotation is visible at runtime.
Returns:
  a visitor to visit the annotation values, or null if this visitor is not interested in visiting this annotation.

### visitAttribute

public final void visitAttribute(Attribute attribute)
Description copied from class: `ClassVisitor`
Visits a non standard attribute of the class.

Overrides:
  `visitAttribute` in class `ClassVisitor`
Parameters:
  `attribute` - an attribute.

### visitNestMember

public final void visitNestMember(String nestMember)
Description copied from class: `ClassVisitor`
Visits a member of the nest. A nest is a set of classes of the same package that share access to their private members. One of these classes, called the host, lists the other members of the nest, which in turn should link to the host of their nest. This method must be called only if the visited class is the host of a nest. A nest host is implicitly a member of its own nest, so it's invalid to call this method with the visited class name as argument.

Overrides:
  `visitNestMember` in class `ClassVisitor`
Parameters:
  `nestMember` - the internal name of a nest member (see `Type.getInternalName()`).

### visitPermittedSubclass

public final void visitPermittedSubclass(String permittedSubclass)
Description copied from class: `ClassVisitor`
Visits a permitted subclasses. A permitted subclass is one of the allowed subclasses of the current class.

Overrides:
  `visitPermittedSubclass` in class `ClassVisitor`
Parameters:
  `permittedSubclass` - the internal name of a permitted subclass (see `Type.getInternalName()`).

### visitInnerClass

public final void visitInnerClass(String name, String outerName, String innerName, int access)
Description copied from class: `ClassVisitor`
Visits information about an inner class. This inner class is not necessarily a member of the class being visited. More precisely, every class or interface C which is referenced by this class and which is not a package member must be visited with this method. This class must reference its nested class or interface members, and its enclosing class, if any. See the JVMS 4.7.6 section for more details.

Overrides:
  `visitInnerClass` in class `ClassVisitor`
Parameters:
  `name` - the internal name of C (see `Type.getInternalName()`).
  `outerName` - the internal name of the class or interface C is a member of (see `Type.getInternalName()`). Must be null if C is not the member of a class or interface (for example, for local or anonymous classes).
  `innerName` - the (simple) name of C. Must be null for anonymous inner classes.
  `access` - the access flags of C originally declared in the source code from which this class was compiled.

### visitRecordComponent

public final RecordComponentVisitor visitRecordComponent(String name, String descriptor, String signature)
Description copied from class: `ClassVisitor`
Visits a record component of the class.

Overrides:
  `visitRecordComponent` in class `ClassVisitor`
Parameters:
  `name` - the record component name.
  `descriptor` - the record component descriptor (see `Type`).
  `signature` - the record component signature. May be null if the record component type does not use generic types.
Returns:
  a visitor to visit this record component annotations and attributes, or null if this class visitor is not interested in visiting these annotations and attributes.

### visitField

public final FieldVisitor visitField(int access, String name, String descriptor, String signature, Object value)
Description copied from class: `ClassVisitor`
Visits a field of the class.

Overrides:
  `visitField` in class `ClassVisitor`
Parameters:
  `access` - the field's access flags (see `Opcodes`). This parameter also indicates if the field is synthetic and/or deprecated.
  `name` - the field's name.
  `descriptor` - the field's descriptor (see `Type`).
  `signature` - the field's signature. May be null if the field's type does not use generic types.
  `value` - the field's initial value. This parameter, which may be null if the field does not have an initial value, must be an `Integer`, a `Float`, a `Long`, a `Double` or a `String` (for `int`, `float`, `long` or `String` fields respectively). This parameter is only used for static fields. Its value is ignored for non static fields, which must be initialized through bytecode instructions in constructors or methods.
Returns:
  a visitor to visit field annotations and attributes, or null if this class visitor is not interested in visiting these annotations and attributes.

### visitMethod

public final MethodVisitor visitMethod(int access, String name, String descriptor, String signature, String[] exceptions)
Description copied from class: `ClassVisitor`
Visits a method of the class. This method must return a new `MethodVisitor` instance (or null) each time it is called, i.e., it should not return a previously returned visitor.

Overrides:
  `visitMethod` in class `ClassVisitor`
Parameters:
  `access` - the method's access flags (see `Opcodes`). This parameter also indicates if the method is synthetic and/or deprecated.
  `name` - the method's name.
  `descriptor` - the method's descriptor (see `Type`).
  `signature` - the method's signature. May be null if the method parameters, return type and exceptions do not use generic types.
  `exceptions` - the internal names of the method's exception classes (see `Type.getInternalName()`). May be null.
Returns:
  an object to visit the byte code of the method, or null if this class visitor is not interested in visiting the code of this method.

### visitEnd

public final void visitEnd()
Description copied from class: `ClassVisitor`
Visits the end of the class. This method, which is the last one to be called, is used to inform the visitor that all the fields and methods of the class have been visited.

Overrides:
  `visitEnd` in class `ClassVisitor`

### toByteArray

public byte[] toByteArray()
Returns the content of the class file that was built by this ClassWriter.

Returns:
  the binary content of the JVMS ClassFile structure that was built by this ClassWriter.
Throws:
  `ClassTooLargeException` - if the constant pool of the class is too large.
  `MethodTooLargeException` - if the Code attribute of a method is too large.

### newConst

public int newConst(Object value)
Adds a number or string constant to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

Parameters:
  `value` - the value of the constant to be added to the constant pool. This parameter must be an `Integer`, a `Float`, a `Long`, a `Double` or a `String`.
Returns:
  the index of a new or already existing constant item with the given value.

### newUTF8

public int newUTF8(String value)
Adds an UTF8 string to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

Parameters:
  `value` - the String value.
Returns:
  the index of a new or already existing UTF8 item.

### newClass

public int newClass(String value)
Adds a class reference to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

Parameters:
  `value` - the internal name of the class (see `Type.getInternalName()`).
Returns:
  the index of a new or already existing class reference item.

### newMethodType

public int newMethodType(String methodDescriptor)
Adds a method type reference to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

Parameters:
  `methodDescriptor` - method descriptor of the method type.
Returns:
  the index of a new or already existing method type reference item.

### newModule

public int newModule(String moduleName)
Adds a module reference to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

Parameters:
  `moduleName` - name of the module.
Returns:
  the index of a new or already existing module reference item.

### newPackage

public int newPackage(String packageName)
Adds a package reference to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

Parameters:
  `packageName` - name of the package in its internal form.
Returns:
  the index of a new or already existing module reference item.

### newHandle

@Deprecated(forRemoval=false) public int newHandle(int tag, String owner, String name, String descriptor)
Deprecated.
this method is superseded by `newHandle(int, String, String, String, boolean)`.
Adds a handle to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

Parameters:
  `tag` - the kind of this handle. Must be `Opcodes.H_GETFIELD`, `Opcodes.H_GETSTATIC`, `Opcodes.H_PUTFIELD`, `Opcodes.H_PUTSTATIC`, `Opcodes.H_INVOKEVIRTUAL`, `Opcodes.H_INVOKESTATIC`, `Opcodes.H_INVOKESPECIAL`, `Opcodes.H_NEWINVOKESPECIAL` or `Opcodes.H_INVOKEINTERFACE`.
  `owner` - the internal name of the field or method owner class (see `Type.getInternalName()`).
  `name` - the name of the field or method.
  `descriptor` - the descriptor of the field or method.
Returns:
  the index of a new or already existing method type reference item.

### newHandle

public int newHandle(int tag, String owner, String name, String descriptor, boolean isInterface)
Adds a handle to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

Parameters:
  `tag` - the kind of this handle. Must be `Opcodes.H_GETFIELD`, `Opcodes.H_GETSTATIC`, `Opcodes.H_PUTFIELD`, `Opcodes.H_PUTSTATIC`, `Opcodes.H_INVOKEVIRTUAL`, `Opcodes.H_INVOKESTATIC`, `Opcodes.H_INVOKESPECIAL`, `Opcodes.H_NEWINVOKESPECIAL` or `Opcodes.H_INVOKEINTERFACE`.
  `owner` - the internal name of the field or method owner class (see `Type.getInternalName()`).
  `name` - the name of the field or method.
  `descriptor` - the descriptor of the field or method.
  `isInterface` - true if the owner is an interface.
Returns:
  the index of a new or already existing method type reference item.

### newConstantDynamic

public int newConstantDynamic(String name, String descriptor, Handle bootstrapMethodHandle, Object... bootstrapMethodArguments)
Adds a dynamic constant reference to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

Parameters:
  `name` - name of the invoked method.
  `descriptor` - field descriptor of the constant type.
  `bootstrapMethodHandle` - the bootstrap method.
  `bootstrapMethodArguments` - the bootstrap method constant arguments.
Returns:
  the index of a new or already existing dynamic constant reference item.

### newInvokeDynamic

public int newInvokeDynamic(String name, String descriptor, Handle bootstrapMethodHandle, Object... bootstrapMethodArguments)
Adds an invokedynamic reference to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

Parameters:
  `name` - name of the invoked method.
  `descriptor` - descriptor of the invoke method.
  `bootstrapMethodHandle` - the bootstrap method.
  `bootstrapMethodArguments` - the bootstrap method constant arguments.
Returns:
  the index of a new or already existing invokedynamic reference item.

### newField

public int newField(String owner, String name, String descriptor)
Adds a field reference to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

Parameters:
  `owner` - the internal name of the field's owner class (see `Type.getInternalName()`).
  `name` - the field's name.
  `descriptor` - the field's descriptor.
Returns:
  the index of a new or already existing field reference item.

### newMethod

public int newMethod(String owner, String name, String descriptor, boolean isInterface)
Adds a method reference to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

Parameters:
  `owner` - the internal name of the method's owner class (see `Type.getInternalName()`).
  `name` - the method's name.
  `descriptor` - the method's descriptor.
  `isInterface` - true if `owner` is an interface.
Returns:
  the index of a new or already existing method reference item.

### newNameType

public int newNameType(String name, String descriptor)
Adds a name and type to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

Parameters:
  `name` - a name.
  `descriptor` - a type descriptor.
Returns:
  the index of a new or already existing name and type item.

### setFlags

public final void setFlags(int flags)
Changes the computation strategy of method properties like max stack size, max number of local variables, and frames.

WARNING: `setFlags(int)` method changes the behavior of new method visitors returned from `visitMethod(int, String, String, String, String[])`. The behavior will be changed only after the next method visitor is returned. All the previously returned method visitors keep their previous behavior.

Parameters:
  `flags` - option flags that can be used to modify the default behavior of this class. Must be zero or more of `COMPUTE_MAXS` and `COMPUTE_FRAMES`.

### getCommonSuperClass

protected String getCommonSuperClass(String type1, String type2)
Returns the common super type of the two given types. The default implementation of this method loads the two given classes and uses the java.lang.Class methods to find the common super class. It can be overridden to compute this common super type in other ways, in particular without actually loading any class, or to take into account the class that is currently being generated by this ClassWriter, which can of course not be loaded since it is under construction.

Parameters:
  `type1` - the internal name of a class (see `Type.getInternalName()`).
  `type2` - the internal name of another class (see `Type.getInternalName()`).
Returns:
  the internal name of the common super class of the two given classes (see `Type.getInternalName()`).

### getClassLoader

protected ClassLoader getClassLoader()
Returns the `ClassLoader` to be used by the default implementation of `getCommonSuperClass(String, String)`, that of this `ClassWriter`'s runtime type by default.

Returns:
  ClassLoader